;;; -*- Mode: Lisp; Syntax: Common-Lisp; Package: SNIP; Base: 10 -*-

;; Copyright (C) 1984, 1988, 1989, 1993 Research Foundation of 
;;                                      State University of New York

;; Version: $Id: new-and.lisp,v 1.1 1993/07/17 02:16:30 snwiz Exp $

;; This file is part of SNePS.

;; SNePS is free software; you may redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; SNePS is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with SNePS; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA, or to
;; Dr. Stuart C. Shapiro, Department of Computer Science, State University of
;; New York at Buffalo, 226 Bell Hall, Buffalo, NY 14260, USA

(in-package :snip)


;-------------------
;  And handler
;-------------------

(defun rule-handler.and (ant-report cqch)
  ; if the antecedents have the same set of variables,
  ; use S-indexing, otherwise use linear ruiset handling    
  (do.set (rui (if (or (null (ants.cqch cqch))
		       (is-all-pat-same-vars (ants.cqch cqch)))
		   (get-rule-use-info-sindexing ant-report cqch)
		   (get-rule-use-info ant-report cqch))
	       t)

      (case (sign.rep ant-report)
	(NEG  (if (equal (signature.rep ant-report)
			 (destination.ch (channel.cqch cqch)))
		  (let ((restr (make.restr (subst.rui rui)))
			(ch (channel.cqch cqch)))
		    (unless-remarkedp.rui
		     rui (remark '"~%I know it is not the case that"
			     (makeone.ns (destination.ch ch)) restr))
		    (send-reports
		     (makeone.repset
		      (make.rep
		       (restrict.sbst (subst.rui rui)
				      (freevars.n *NODE*))
		       (compute-new-support.and ch rui ant-report)
		       'NEG
		       *NODE*
		       nil
		       (context.ch ch)))
		     ch))))
	
	(POS  (if (or (equal (signature.rep ant-report)
			     (destination.ch (channel.cqch cqch)))
		      (equal (match::applysubst *NODE*
						(subst.rep ant-report))
			     (node.rep ant-report)))
		  (let ((restr (make.restr (subst.rui rui)))
			(ch (channel.cqch cqch)))
		    (unless-remarkedp.rui
		     rui (remark '"~%It is the case that"
				 (makeone.ns (destination.ch ch)) restr))
		    (send-reports
		     (makeone.repset
		      (make.rep
		       (restrict.sbst (subst.rui rui)
				      (freevars.n (destination.ch ch)))
		       (compute-new-support.and ch rui ant-report)
		       'POS
		       *NODE*
		       nil
		       (context.ch ch)
		       ))
		     ch)))))))
